

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}


--======================================================================VALUES========================================================================
local waterSplash = 	sounds.createSFXSource('art/sound/watersplash.ogg', 	'AudioDefault3D', 		"Watersplash", 		v.data.refNodes[0].ref)
local woosh = 			sounds.createSFXSource('art/sound/woosh.ogg', 		    'AudioDefault3D',       "woosh",			v.data.refNodes[0].ref)
local waterSoundTable = {}

local cameraMode
local iTable = {} -- Contain all tire timers
local iTableSave
local iTableBoolean = false
local tireTimerThreshold
local wheelNB = 0
local waterVolume = 0
local waterPitch = 0
local waterDelay = {}
local stillUnderWater = 0
--======================================================================VALUES========================================================================







local function onVehicleSwitched()	
	sounds.playSoundOnceAtNode("woosh", v.data.refNodes[0].ref,  1)	
	obj:queueGameEngineLua("core_camera.switchCamera(0, 1) 	core_camera.switchCamera(0, -1)")
end







--=========================================INITILIZATION===========================================
local function onInit()
	iTable = {}
end
--=========================================INITILIZATION===========================================







local function updateGFX(dt)

	-- I don't remember what this code do
	obj:queueGameEngineLua("if be:getPlayerVehicle(0) ~= nil then be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switchActual = (\"'..be:getPlayerVehicleID(0)..'\") end ') end")
	if drivingSounds.switch == nil then drivingSounds.switch = drivingSounds.switchActual end
	if drivingSounds.switchActual ~= drivingSounds.switch then
		drivingSounds.cameraMode = "orbit"
	end

	if wheelNB > #wheels.wheels then wheelNB = 0 end
	if wheels.wheels[wheelNB] ~= nil then
	--==================================SOME CODE====================================	
		local wi = wheels.wheels[wheelNB]
		local w = wi.obj    
		local velocity = vec3(obj:getVelocity()):length()
		local wheelspeed = math.abs(w.angularVelocity * wi.radius)    
		local underWater = obj:inWater(wi.node1) and 1 or 0
		
		if waterSound == nil then
			for _, wi in pairs(wheels.wheels) do
				waterSoundTable[wi.node1] = sounds.createSFXSource('art/sound/water.ogg', 'AudioDefaultLoop3D', "WaterSound"..wi.node1, wi.node1)	
			end		
		end
		
		for _, wi in pairs(wheels.wheels) do
			if iTable[wi.node1] == nil then 
				iTable[wi.node1] = 1
			end	
			if waterDelay[wi.node1] == nil then 
				waterDelay[wi.node1] = 0
			end	
		end
	--==================================SOME CODE====================================		
		



		
		
			
	--====================================================================TIRE SMOKE======================================================================			
		if wi.contactMaterialID1 == 10 and wi.contactMaterialID2 == 4 and wi.contactDepth == 0  then --If drive on road
			if wi.slipEnergy > 10000 then -- If skid vol and skid pitch mean that the player is drifting
				iTableBoolean = false
				if iTable[wi.node1] < 8.75 then iTable[wi.node1] = iTable[wi.node1] + dt end -- Increase delay (in seconds)
				
				if iTable[wi.node1] > 2 and iTable[wi.node1] < 3.75 then -- If player is drifting more than 3s then
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 4)
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 6, 1, 4) end
		  
				if iTable[wi.node1] > 3.75 and iTable[wi.node1] < 6.25 then -- If player is drifting more than 15s then
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 6, 1, 2)
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 2)
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 22, 1, 2) end
		  
				if iTable[wi.node1] > 6.25 then -- If player is drifting more than 25s then
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 35, 1, 2)
					obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1) , 37, 1, 2) end
			elseif wi.slipEnergy < 10000 and iTable[wi.node1] > 1 then				
				iTable[wi.node1] = iTable[wi.node1] - dt -- Reduce the delay slowly when the player stop drifting					
				if iTable[wi.node1] > 3.75 then -- If user drift over more than 15s
					if iTableBoolean == false then iTableSave = iTable[wi.node1] iTableBoolean = true end -- Save iTableSave
					if iTableSave < iTable[wi.node1] + 4 then -- Smoke come frome wheel for 3s
						if math.random(10) == 5 then -- Generate smoke
							obj:addParticleByNodesRelative(wi.node1, wi.node2, 4, 22, 0.4, 2)
							obj:addParticleByNodesRelative(wi.node1, wi.node2, 4, 6, 0.2, 2)
						end
					end
				end	
			end
		end
	--====================================================================TIRE SMOKE======================================================================				
		
		
		

		
		
		
	--=========================================================DIRT AND SAND PARTICLES===========================================================		
		if wi.contactMaterialID1 == 16 or wi.contactMaterialID1 == 20 or wi.contactMaterialID1 == 19 then -- If driving on sand or dirt    
			obj:addParticleByNodesRelative(wi.node1, wi.node2, 0.5 , 3, 0.1, wheelspeed/8) -- Dirt particles
		end
		if wi.contactMaterialID1 == 20 or wi.contactMaterialID1 == 19 then -- If drifting on dirt
			if wi.slipEnergy > 10000 then
				obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1), 3, 0.1, 2) -- Dirt particles
				obj:addParticleByNodesRelative(wi.node1, wi.node2, 1-math.random(1), 18, 0.3, 1) -- mud particles
			end
		end	
	--=========================================================DIRT AND SAND PARTICLES===========================================================





		


	--============================================================================WATER SOUND AND PARTICLES============================================================================	
			if underWater == 1 or wi.contactMaterialID1 == 12 or wi.contactMaterialID1 == 11 then	-- If the vehicle is under water		
				iTable[wi] = 1 -- Reset drifting timer because the tire cool down
				local particlesSpeed = wheelspeed/2
				local particlesAmount = wheelspeed
				if particlesAmount > 10 then particlesAmount = 10 end
				if particlesSpeed > 3 then particlesSpeed = 3 end
				obj:addParticleByNodesRelative(wi.node2, wi.node1, particlesSpeed, 50, 0.3, particlesAmount)	-- Particles when drive in water
				if wi.isBroken == false then -- If wheel is not broken
					waterVolume = velocity*0.03+wheelspeed*0.03
					if waterVolume > 1 then waterVolume = 1 end			
					waterPitch = velocity*0.10+wheelspeed*0.10				
					obj:setVolumePitch(waterSoundTable[wi.node1], waterVolume, waterPitch) 	
				end
				if wi.isBroken == false and stillUnderWater == 0 then -- Wheel is not broken and still under water
						sounds.playSoundOnceAtNode("waterSplash", v.data.refNodes[0].ref, velocity/20)
				end
				stillUnderWater = 1
			else
				if waterVolume ~= 0 and waterPitch ~= 0 then
					waterDelay[wi.node1] = waterDelay[wi.node1] + dt				
					if waterVolume - dt < 0 then waterVolume = 0 else waterVolume = waterVolume - dt*1.5 end
					if waterPitch - dt < 0 then waterPitch = 0 else waterPitch = waterPitch - dt*1.5 end			
					obj:setVolumePitch(waterSoundTable[wi.node1], waterVolume, waterPitch)	
				else
					stillUnderWater = 0
				end
			end
	--============================================================================WATER SOUND AND PARTICLES============================================================================			
		wheelNB = wheelNB + 1
	end
end


M.onVehicleSwitched  = onVehicleSwitched
M.jsonInit	   		 = jsonInit
M.onReset 	   		 = onInit
M.focusLost    		 = focusLost
M.focusGained 		 = focusGained
M.updateGFX 		 = updateGFX

return M