
angular.module('beamng.apps')
.directive('sahMod', ['UiUnits', function (UiUnits) {
  return {  
    template: 
      '<div style="max-height:100%; width:100%; background:transparent;" layout="row" layout-align="center center" layout-wrap>' +
      '<md-button flex id="btBrakes" style="margin: 2px; min-width: 40px; min-height: 40px;" md-no-ink class="md-raised" ng-click="brakesClick()">B:0</md-button>' +
      '</div>',
	  
    replace: true,
    restrict: 'EA',
    scope: true,
	
    controller: ['$log', '$scope', 'bngApi', function ($log, $scope, bngApi) { 
		$scope.$on('$destroy', function () {
		});

		var brakesToggle = false;

		$scope.brakesClick = function() {
			if (brakesToggle === false) {
				document.getElementById("btBrakes").textContent="B:1";
				brakesToggle = true;
				bngApi.engineLua('sahmod.brakes(true)')
			} else {
				document.getElementById("btBrakes").textContent="B:0";
				brakesToggle = false;
				bngApi.engineLua('sahmod.brakes(false)')
			}	
		};
		
    }]
  };
}]);